#ifndef __CDB_MEM_DATABASE_H__
#define __CDB_MEM_DATABASE_H__


#include <cstdint>
#include <vector>
#include <utility>
#include <map>
#include "CDBField.h"
#include "CDBTableFields.h"
#include "CDBTables.h"


class CDBMemDataBase
{
public:
	int64_t tableLocalPathsAddLine(const CDBTablePathLine &pathLine);
	std::vector<CIDLinePath> tableLocalPathsReadAllLines();

	int64_t tableRemotePathsAddLine(const CDBTablePathLine &pathLine);
	std::vector<CIDLinePath> tableRemotePathsReadAllLines();

	int64_t tableServersAddLine(const CDBTableServerLine &serverLine);
	std::vector<CIDLineServer> tableServersReadAllLines();

	int64_t tableFilesAddLine(const CDBTableFileLine &fileLine);
	std::vector<CIDLineFile> tableFilesReadAllLinesByServerId(int64_t serverId);

	std::vector<uint8_t> toRawData() const;
	static CDBMemDataBase fromRawData(const std::vector<uint8_t> &rawData);

protected:
	void updateCache();

protected:
	CDBTablePath tableLocalPaths;
	CDBTablePath tableRemotePaths;
	CDBTableServer tableServers;
	CDBTableFile tableFiles;

private:
	std::map<int64_t, std::vector<CIDLineFile>> mMapServerIdToFileLines;
};


#endif //__CDB_MEM_DATABASE_H__
