#ifndef __CDB_TABLE_FIELDS_H__
#define __CDB_TABLE_FIELDS_H__


#include "CDBField.h"
#include <cstdint>
#include <vector>
#include <utility>




/*
Column cry_server_table_columns[] = {
	{ _T("id"), Column_type::integer, Column_flags::not_null | Column_flags::autoincrement },

	{ _T("host"), Column_type::text, Column_flags::not_null },
	{ _T("port"), Column_type::integer, 0 },
	{ _T("user"), Column_type::text, 0 },
	{ _T("password"), Column_type::text, 0 },
	{ _T("account"), Column_type::text, 0 },
	{ _T("protocol"), Column_type::integer, 0 },
	{ _T("type"), Column_type::integer, 0 },
	{ _T("logontype"), Column_type::integer, 0 },
	{ _T("timezone_offset"), Column_type::integer, 0 },
	{ _T("transfer_mode"), Column_type::text, 0 },
	{ _T("max_connections"), Column_type::integer, 0 },
	{ _T("encoding"), Column_type::text, 0 },
	{ _T("bypass_proxy"), Column_type::integer, 0 },
	{ _T("post_login_commands"), Column_type::text, 0 },
	{ _T("name"), Column_type::text, 0 }
};
*/
class CDBTableServerLine
{
public:
	CDBFieldText host;					//{ _T("host"), Column_type::text, Column_flags::not_null },
	CDBFieldInteger port;				//{ _T("port"), Column_type::integer, 0 },
	CDBFieldText user;					//{ _T("user"), Column_type::text, 0 },
	CDBFieldText password;				//{ _T("password"), Column_type::text, 0 },
	CDBFieldText account;				//{ _T("account"), Column_type::text, 0 },
	CDBFieldInteger protocol;			//{ _T("protocol"), Column_type::integer, 0 },
	CDBFieldInteger type;				//{ _T("type"), Column_type::integer, 0 },
	CDBFieldInteger logontype;			//{ _T("logontype"), Column_type::integer, 0 },
	CDBFieldInteger timezone_offset;	//{ _T("timezone_offset"), Column_type::integer, 0 },
	CDBFieldText transfer_mode;			//{ _T("transfer_mode"), Column_type::text, 0 },
	CDBFieldInteger max_connections;	//{ _T("max_connections"), Column_type::integer, 0 },
	CDBFieldText encoding;				//{ _T("encoding"), Column_type::text, 0 },
	CDBFieldInteger bypass_proxy;		//{ _T("bypass_proxy"), Column_type::integer, 0 },
	CDBFieldText post_login_commands;	//{ _T("post_login_commands"), Column_type::text, 0 },
	CDBFieldText name;					//{ _T("name"), Column_type::text, 0 }
public:
	std::vector<uint8_t> toRawData() const;
	static CDBTableServerLine fromRawData(const std::vector<uint8_t> &rawData);
	
	inline wxString toString()
	{
		wxString res = _T("CDBTableServerLine:\n");
		
		res += wxString(_T("host=")) + host.toString() + _T("\n");
		res += wxString(_T("port=")) + port.toString() + _T("\n");
		res += wxString(_T("user=")) + user.toString() + _T("\n");
		res += wxString(_T("password=")) + password.toString() + _T("\n");
		res += wxString(_T("account=")) + account.toString() + _T("\n");
		res += wxString(_T("protocol=")) + protocol.toString() + _T("\n");
		res += wxString(_T("type=")) + type.toString() + _T("\n");
		res += wxString(_T("logontype=")) + logontype.toString() + _T("\n");
		res += wxString(_T("timezone_offset=")) + timezone_offset.toString() + _T("\n");
		res += wxString(_T("transfer_mode=")) + transfer_mode.toString() + _T("\n");
		res += wxString(_T("max_connections=")) + max_connections.toString() + _T("\n");
		res += wxString(_T("encoding=")) + encoding.toString() + _T("\n");
		res += wxString(_T("bypass_proxy=")) + bypass_proxy.toString() + _T("\n");
		res += wxString(_T("post_login_commands=")) + post_login_commands.toString() + _T("\n");
		res += wxString(_T("name=")) + name.toString();

		return res;
	}
};

inline bool operator==(const CDBTableServerLine &a, const CDBTableServerLine &b)
{
	return	(a.host					== b.host) &&
			(a.port					== b.port) &&
			(a.user					== b.user) &&
			(a.password				== b.password) &&
			(a.account				== b.account) &&
			(a.protocol				== b.protocol) &&
			(a.type					== b.type) &&
			(a.logontype			== b.logontype) &&
			(a.timezone_offset		== b.timezone_offset) &&
			(a.transfer_mode		== b.transfer_mode) &&
			(a.max_connections		== b.max_connections) &&
			(a.encoding				== b.encoding) &&
			(a.bypass_proxy			== b.bypass_proxy) &&
			(a.post_login_commands	== b.post_login_commands) &&
			(a.name					== b.name);
}





/*
Column cry_file_table_columns[] = {
	{ _T("id"), Column_type::integer, Column_flags::not_null | Column_flags::autoincrement },

	{ _T("server"), Column_type::integer, Column_flags::not_null },
	{ _T("source_file"), Column_type::text, 0 },
	{ _T("target_file"), Column_type::text, 0 },
	{ _T("local_path"), Column_type::integer, 0 },
	{ _T("remote_path"), Column_type::integer, 0 },
	{ _T("download"), Column_type::integer, Column_flags::not_null },
	{ _T("size"), Column_type::integer, 0 },
	{ _T("error_count"), Column_type::integer, 0 },
	{ _T("priority"), Column_type::integer, 0 },
	{ _T("ascii_file"), Column_type::integer, 0 },
	{ _T("default_exists_action"), Column_type::integer, 0 }
};
*/
class CDBTableFileLine
{
public:
	CDBFieldInteger server_id;				//{ _T("server"), Column_type::integer, Column_flags::not_null },
	CDBFieldText source_file;				//{ _T("source_file"), Column_type::text, 0 },
	CDBFieldText target_file;				//{ _T("target_file"), Column_type::text, 0 },
	CDBFieldInteger local_path_id;			//{ _T("local_path"), Column_type::integer, 0 },
	CDBFieldInteger remote_path_id;			//{ _T("remote_path"), Column_type::integer, 0 },
	CDBFieldInteger download;				//{ _T("download"), Column_type::integer, Column_flags::not_null },
	CDBFieldInteger size;					//{ _T("size"), Column_type::integer, 0 },
	CDBFieldInteger error_count;			//{ _T("error_count"), Column_type::integer, 0 },
	CDBFieldInteger priority;				//{ _T("priority"), Column_type::integer, 0 },
	CDBFieldInteger ascii_file;				//{ _T("ascii_file"), Column_type::integer, 0 },
	CDBFieldInteger default_exists_action;	//{ _T("default_exists_action"), Column_type::integer, 0 }
public:
	std::vector<uint8_t> toRawData() const;
	static CDBTableFileLine fromRawData(const std::vector<uint8_t> &rawData);

	inline wxString toString()
	{
		wxString res = _T("CDBTableFileLine:\n");

		res += wxString(_T("server_id=")) + server_id.toString() + _T("\n");
		res += wxString(_T("source_file=")) + source_file.toString() + _T("\n");
		res += wxString(_T("target_file=")) + target_file.toString() + _T("\n");
		res += wxString(_T("local_path_id=")) + local_path_id.toString() + _T("\n");
		res += wxString(_T("remote_path_id=")) + remote_path_id.toString() + _T("\n");
		res += wxString(_T("download=")) + download.toString() + _T("\n");
		res += wxString(_T("size=")) + size.toString() + _T("\n");
		res += wxString(_T("error_count=")) + error_count.toString() + _T("\n");
		res += wxString(_T("priority=")) + priority.toString() + _T("\n");
		res += wxString(_T("ascii_file=")) + ascii_file.toString() + _T("\n");
		res += wxString(_T("default_exists_action=")) + default_exists_action.toString() + _T("\n");

		return res;
	}
};

inline bool operator==(const CDBTableFileLine &a, const CDBTableFileLine &b)
{
	return	(a.server_id				== b.server_id) &&
			(a.source_file				== b.source_file) &&
			(a.target_file				== b.target_file) &&
			(a.local_path_id			== b.local_path_id) &&
			(a.remote_path_id			== b.remote_path_id) &&
			(a.download					== b.download) &&
			(a.size						== b.size) &&
			(a.error_count				== b.error_count) &&
			(a.priority					== b.priority) &&
			(a.ascii_file				== b.ascii_file) &&
			(a.default_exists_action	== b.default_exists_action);
}





/*
Column cry_path_table_columns[] = {
	{ _T("id"), Column_type::integer, Column_flags::not_null | Column_flags::autoincrement },

	{ _T("path"), Column_type::text, Column_flags::not_null }
};
*/
class CDBTablePathLine
{
public:
	CDBFieldText path;	//{ _T("path"), Column_type::text, Column_flags::not_null }
public:
	std::vector<uint8_t> toRawData() const;
	static CDBTablePathLine fromRawData(const std::vector<uint8_t> &rawData);

	inline wxString toString()
	{
		wxString res = _T("CDBTablePathLine:\n");

		res += wxString(_T("path=")) + path.toString() + _T("\n");

		return res;
	}

};

inline bool operator==(const CDBTablePathLine &a, const CDBTablePathLine &b)
{
	return	(a.path == b.path);
}





typedef std::pair<int64_t, CDBTableServerLine> CIDLineServer;
typedef std::pair<int64_t, CDBTableFileLine> CIDLineFile;
typedef std::pair<int64_t, CDBTablePathLine> CIDLinePath;



#endif // __CDB_TABLE_FIELDS_H__
