#include "Common.h"
#include "msgbox.h"
#include <cstdint>
#include <cstdio>
#include <cstdlib>


wxString arrayToHex(const uint8_t *arr, size_t len)
{
	wxString res;
	for (size_t i = 0; i < len; ++i)
	{
		char tmp[10] = { 0 };
		sprintf(tmp, "%02X", (uint8_t)arr[i]);
		res += tmp;
	}
	return res;
}

wxString arrayToHex(const std::vector<uint8_t> &arr)
{
	return arrayToHex(arr.data(), arr.size());
}

wxString int64ToHex(int64_t val)
{
	return arrayToHex((uint8_t*)&val, sizeof(val));
}

void showDebugMsg(const wxString &msg)
{
	wxMessageBoxEx(msg);
}

std::vector<uint8_t> wxStringToRawData(const wxString &str)
{
	if (str.Length() > 0)
	{
		wxCharBuffer chbuf = str.utf8_str();
		const uint8_t *buf = (uint8_t *)chbuf.data();
		const size_t len = (size_t)chbuf.length();

		std::vector<uint8_t> raw(len, 0);
		memcpy(raw.data(), buf, raw.size());

		return raw;
	}

	return std::vector<uint8_t>();
}

wxString wxStringFromRawData(const std::vector<uint8_t> &raw)
{
	if (raw.size() > 0)
	{
		std::vector<uint8_t> zraw(raw.size() + 10, 0);
		memcpy(zraw.data(), raw.data(), raw.size());

		const char *buf = (const char *)(zraw.data());

		wxString res = wxString::FromUTF8(buf);

		return res;
	}

	return wxString();
}
