#ifndef __CRYPTED_DATA_BASE_FILE_H__
#define __CRYPTED_DATA_BASE_FILE_H__


#include <wx/string.h>
#include <vector>
#include <cstdint>
#include "CryptFiles.h"


class CryptedDataBaseFile
{
public:
	explicit CryptedDataBaseFile(CryptFileType cfType);
	virtual ~CryptedDataBaseFile();

	CryptedDataBaseFile(CryptedDataBaseFile const&) = delete;
	CryptedDataBaseFile& operator=(CryptedDataBaseFile const&) = delete;


	bool loadRawDataAndClearFile(std::vector<uint8_t> &data);
	bool saveRawDataToFile(const std::vector<uint8_t> &data);

protected:
	
	bool saveFile(const std::vector<uint8_t> &data);
	bool clearFile();
	bool loadFile(std::vector<uint8_t> &data);	

private:
	CryptFileType mCfType;
};


#endif //__CRYPTED_DATA_BASE_FILE_H__
