#include "CryptedQueueDataBase.h"
#include <stdlib.h>
#include <filezilla.h>
#include "queue.h"
#include "Mainfrm.h"
#include "Options.h"



CryptedQueueDataBase::CryptedQueueDataBase(CryptFileType cfType)
	: mDbFile(cfType), mDBMemDataBase()
{
}

CryptedQueueDataBase::~CryptedQueueDataBase()
{
}

bool CryptedQueueDataBase::loadDBFromCryptedFileAndClearFile()
{
	std::vector<uint8_t> rawData;
	if (mDbFile.loadRawDataAndClearFile(rawData))
	{
		mDBMemDataBase = CDBMemDataBase::fromRawData(rawData);
		return true;
	}

	return false;
}

bool CryptedQueueDataBase::saveDBToCryptedFile()
{
	const std::vector<uint8_t> rawData = mDBMemDataBase.toRawData();
	if (mDbFile.saveRawDataToFile(rawData))
		return true;

	return false;
}


int64_t CryptedQueueDataBase::tableLocalPathsAddLine(const CDBTablePathLine & pathLine)
{
	const int64_t idLocal = mDBMemDataBase.tableLocalPathsAddLine(pathLine);
	if (idLocal > 0)
		return idLocal;

	return -1;
}

std::vector<CIDLinePath> CryptedQueueDataBase::tableLocalPathsReadAllLines()
{
	std::vector<CIDLinePath> mem_lines = mDBMemDataBase.tableLocalPathsReadAllLines();
	return mem_lines;
}

int64_t CryptedQueueDataBase::tableRemotePathsAddLine(const CDBTablePathLine & pathLine)
{
	const int64_t idRemote = mDBMemDataBase.tableRemotePathsAddLine(pathLine);
	if (idRemote > 0)
		return idRemote;

	return -1;
}

std::vector<CIDLinePath> CryptedQueueDataBase::tableRemotePathsReadAllLines()
{
	std::vector<CIDLinePath> mem_lines = mDBMemDataBase.tableRemotePathsReadAllLines();
	return mem_lines;
}

int64_t CryptedQueueDataBase::tableFilesAddLine(const CDBTableFileLine & fileLine)
{
	const int64_t file_id = mDBMemDataBase.tableFilesAddLine(fileLine);
	if (file_id > 0)
		return file_id;

	return -1;
}

std::vector<CIDLineFile> CryptedQueueDataBase::tableFilesReadAllLinesByServerId(int64_t serverId)
{
	std::vector<CIDLineFile> mem_lines = mDBMemDataBase.tableFilesReadAllLinesByServerId(serverId);
	return mem_lines;
}

int64_t CryptedQueueDataBase::tableServersAddLine(const CDBTableServerLine & serverLine)
{
	const int64_t server_id = mDBMemDataBase.tableServersAddLine(serverLine);
	if (server_id > 0)
		return server_id;

	return -1;
}

std::vector<CIDLineServer> CryptedQueueDataBase::tableServersReadAllLines()
{
	std::vector<CIDLineServer> mem_lines = mDBMemDataBase.tableServersReadAllLines();
	return mem_lines;
}
