#ifndef __CRYPTED_QUEUE_DATA_BASE_H__
#define __CRYPTED_QUEUE_DATA_BASE_H__

#include "CryptedDataBaseFile.h"
#include <wx/string.h>
#include "CDBField.h"
#include "CDBTableFields.h"
#include <utility>
#include <vector>
#include <cstdint>
#include <wx/string.h>
#include <wx/strconv.h>
#include <wx/hashmap.h>
#include <unordered_map>
#include <map>
#include "CDBMemDataBase.h"


class CryptedQueueDataBase
{
public:
	explicit CryptedQueueDataBase(CryptFileType cfType);
	virtual ~CryptedQueueDataBase();

	CryptedQueueDataBase(CryptedQueueDataBase const&) = delete;
	CryptedQueueDataBase& operator=(CryptedQueueDataBase const&) = delete;

	bool loadDBFromCryptedFileAndClearFile();
	bool saveDBToCryptedFile();

	int64_t tableLocalPathsAddLine(const CDBTablePathLine &pathLine);
	std::vector<CIDLinePath> tableLocalPathsReadAllLines();

	int64_t tableRemotePathsAddLine(const CDBTablePathLine &pathLine);
	std::vector<CIDLinePath> tableRemotePathsReadAllLines();

	int64_t tableServersAddLine(const CDBTableServerLine &serverLine);
	std::vector<CIDLineServer> tableServersReadAllLines();

	int64_t tableFilesAddLine(const CDBTableFileLine &fileLine);
	std::vector<CIDLineFile> tableFilesReadAllLinesByServerId(int64_t serverId);
	
private:
	CryptedDataBaseFile mDbFile;
	CDBMemDataBase mDBMemDataBase;
};


#endif //__CRYPTED_QUEUE_DATA_BASE_H__
