#ifndef __SHA_MASTER_PASS_H__
#define __SHA_MASTER_PASS_H__

#include <string>
#include <cstdint>
#include <vector>
#include <cstdio>
#include <wx/string.h>
#include "msgbox.h"
#include <cstring>
#include "AesFile.h"

class ShaMasterPass
{
public:
	explicit ShaMasterPass(const wxString &pass);
	virtual ~ShaMasterPass();

	AesFile::KeyFile generateKeyForFile(const std::string &fileName);

protected:
	static void calcSHA512(const uint8_t *data, size_t data_size, uint8_t out_hash[64]);
	void generateMasterPassHash(const wxString &pass);

private:
	// Master Password Hash SHA-512
	uint8_t sha512MasterPass[64]{};
};

#endif  // __SHA_MASTER_PASS_H__
